;******************************************************************************
;                                                                             *
; Copyright (C) 2012 Sergio García-Cuevas González.                           *
;                                                                             *
; This program is free software; you can redistribute it and/or modify        *
; it under the terms of the GNU General Public License as published by        *
; the Free Software Foundation; either version 3 of the License, or           *
; (at your option) any later version.                                         *
;                                                                             *
; This program is distributed in the hope that it will be useful,             *
; but WITHOUT ANY WARRANTY; without even the implied warranty of              *
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
; GNU General Public License for more details.                                *
;                                                                             *
; You should have received a copy of the GNU General Public License           *
; along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
;                                                                             *
;******************************************************************************

        list      p=12f629
        #include <p12f629.inc>
        #include "asm/config.inc"

        GLOBAL  counter,duty,new_cmd,old_cmd,pulses,sGPIO,stable,state

VARIABLES_UDATA UDATA_SHR
counter RES     1       ; Running pulse counter.
duty    RES     1       ; Duty cycle counter.
new_cmd RES     1       ; The newly-received command.
old_cmd RES     1       ; The previously-received command.
pulses  RES     1       ; Final value of the pulse counter.
sGPIO   RES     1       ; Shadow-copy of GPIO.
stable  RES     1       ; Count-down for stability.
state   RES     1       ; Bookkeeping variable.

        END
